<template>
  <div>
    <b-navbar id="navbarMain" toggleable="lg" type="dark" variant="info">
      <b-navbar-brand href="#" v-if="currentUserName===''">Micro-Blogage</b-navbar-brand>
      <b-navbar-brand href="#" v-else-if="$route.name==='profilepage'">Hello! {{currentUserName}} Check Your Profile!</b-navbar-brand>
      <b-navbar-brand href="#" v-else>Hello! {{ currentUserName }}, Check Your friend's Posts!</b-navbar-brand>
      <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>
      <b-navbar-nav class="mr-auto">
        <b-nav-form>
        </b-nav-form>
      </b-navbar-nav>
      <div>
        <div v-if="isLogin">
          <b-nav-form class="login">
                  <b-button v-if="isHome" id="returnToMaiPpage" size="md" @click.prevent="saveEditedProfil()" class="mr-2"> Save Changes</b-button>
                  <b-button v-if="isHome" id="returnToMaiPpage2" size="md" @click.prevent="returnHomePage()" class="mr-2"> Home</b-button>
                  <b-button v-if="isProfile" id="profile" size="md" @click.prevent="submitprofile()" class="mr-2"> Profile</b-button>
                  <b-button id="deconnect" size="md" @click.prevent="logOut()" class="mr-2"> Log Out</b-button>
                  <!-- Another way to du button <input v-if="isHome" size="lg" type="submit" name="returnToMaiPpage"
                    id="returnToMaiPpage" value="Save Changes" @click.prevent="saveEditedProfil()"/> -->
          </b-nav-form>
        </div>
        <div v-else>
          <b-nav-form>
            <input
              type="text"
              name="login"
              id="login"
              placeholder=" login"
              v-model="login"
            />
            <input
              type="password"
              name="mdp"
              id="password"
              placeholder=" password"
              v-model="password"
            />
            <b-button  id="connect" size="md" @click.prevent="submit()" class="mr-2" >Enter</b-button>
          </b-nav-form>
        </div>
        <footer class="footer">
          <div class="footer-container">© 2021 Clément / LiFang - All rights reserved
          </div>
        </footer>
      </div>
    </b-navbar>
  </div>
</template>

<script>
import { login } from "../api_wrapper/api_calls.js";
import Cookies from "js-cookie";
import { eventBus } from './event.js';
import { getUserById } from "../api_wrapper/api_calls.js";
import { saveInfos } from '../api_wrapper/api_saveInfos'

export default {
  name: "Navbar",

  data() {
    return {
      pageName: this.$route.name, //get page name
      login: '',
      email: '',
      password: '',
      isError: false, //show error condition with v-if
      isLogin: false,
      isHome: false, 
      isProfile: false,
      currentUserName:''
    };
  },
  //Once the components were created, we call the function in mounted()
  //Cookie.get("name of coookie") for get user info if there's a user connected
  async mounted() {
    const userId = Cookies.get("user_id");

    if (!userId) {
      this.isLogin = false; //if there's no id_user in Cookies, we don't present the content of user
      return;
    }
    
    const user = await getUserById(userId);
    this.currentUserName = user.login_user; //when we return from other page, still have correct user name
    this.isLogin = true;
    //when navbar created, choice which button to show
    this.isHome = this.$route.name === 'homepage' ? false : true;
    this.isProfile = this.$route.name === 'profilepage' ? false : true;

  },

  methods: {
    returnHomePage(){
      this.isHome = false;
      this.isProfile = true;
      this.$router.push({name: 'homepage'})
    },
    
    saveEditedProfil(){
      var data = Cookies.get();
      saveInfos(data);
    },
    
    async submit() {
      //get login and password which user gives
      this.isError = false;
      this.isProfile = true;
      this.isHome = false;
      const authen = await login(this.login, this.password);
      if (!authen || authen.err) {
        //if no match login or no match password, send error
        this.isError = true;
        alert("No Match Login Info");
        return;
      } else {
        //successfully login
        //create cookie : add it in front : have to do : npm install js-cookie --save
        //Cookie.set(<name of cookie>, <value of cookies>)
        Cookies.set("user_id", authen.id_user);
        this.isLogin = true;
        this.currentUserName = this.login;
        //emit : send signal : "there's a change", check it out!
        eventBus.$emit('refreshPage', authen);

      }
    },

    //for log out, no need to do async
    logOut() {
      Cookies.remove("user_id"); //deleted cookies
      Cookies.remove("login");
      Cookies.remove("email");
      Cookies.remove("intro");
      this.isLogin = false; //get back to home page
      eventBus.$emit('logOut'); //after login, we're already at main page, cannot force to go back so user emit here
      const path = `/`;
      this.currentUserName = "";
    if (this.$route.path !== path) this.$router.push(path)
      
    },

    async submitprofile() {
      this.isProfile = false; //for hiding profile button in profile page
      this.isHome = true; //for showing home button in profile page
      this.$router.push({name:'profilepage'});
    },
  },
};
</script>

<style>


#navbarMain{
  height:7vh;
  background-color:transparent !important;
}

#searchBar {
  width: 280pt;
  left: 5pt;
  border-color:transparent;
}

#login,
#password{
  width: 100pt;
  height: 4vh;
  margin-right: 10px;
  border-radius: 0.550rem;
  border-color :transparent !important;
  text-align: center;
  
}

#connect,
#returnToMaiPpage,
#returnToMaiPpage2,
#profile,
#deconnect,
.btn
{
  width: 100pt;
  height: 4vh;
  margin-right: 7px;
  border-radius: 0.50rem;
  text-align: center;
  background-color:transparent;
  border-color: transparent;
}

::placeholder{
  color:#91989F;
}

footer{
    color:white;
    text-align: center;
    position: fixed;
    bottom : 0;
    height: 4vh;
    left :20%;
    width: 60%;
}

</style>
